class Sheep { 

  PVector location;
  PVector velocity;
  PVector acceleration;
  float topspeed;  //limiting the acceleration
  boolean thrusting = false;
  float damping = 0.95; // really sensitive
  float heading = -1.55; // the spinning things

  float r = 16;

  float am = -0.65;
  float mass;

  ArrayList<PVector> history;



  Sheep() {
    // location = new PVector(random(width), random(height));
    velocity = new PVector(0, 0);
    acceleration = new PVector(-0.000002, 0.000002);
    topspeed = 8.0;
    mass = 1;

    location = new PVector(width/2, height/2);
    history = new ArrayList<PVector>();
  } 

  void update() {

    velocity.add(acceleration);
    velocity.mult(damping);
    velocity.div(mass);

    velocity.limit(topspeed);
    location.add(velocity);
    acceleration.mult(0);

    if ((location.x > width) || (location.x < 0)) {
      velocity.x = velocity.x * -1;
    }
    if ((location.y > height) || (location.y < 0)) {
      velocity.y = velocity.y * -1;
    }
  }

  //collision attempt #n
  public boolean isHit(Particle p) {
    //PVector  v1 = new PVector(location.x, location.y, 0);
    //PVector  v2 = new PVector(p.location.x,p.location.y, 0); 
    float d = location.dist(p.location);
    // Compare distance to sum of radii
    if (d < 40) {      
      score++;
      return true;
    } 
    else {
      return false;
    }
  }


  public boolean isHurt(Walker w) {
    //PVector  v1 = new PVector(location.x, location.y, 0);
    //PVector  v2 = new PVector(p.location.x,p.location.y, 0); 
    float d = location.dist(w.location);
    // Compare distance to sum of radii
    if (d < 50) {      
      println("i am hurt!");
      score--;
      return true;
    } 
    else {
      return false;
    }
  }

  void turn(float a) { //ex
    heading += a;
  }

  void thrust() { // this is moving forward
    // Offset the angle since we drew the ship vertically
    float angle = heading;
    // Polar to cartesian for force vector!
    PVector force = new PVector(cos(angle), sin(angle));
    force.mult(1.00);
    applyForce(force); 
    // To draw booster
    thrusting = true;
  }

  void thrust1() { //this is moving backwards
    // Offset the angle since we drew the ship vertically
    float angle = heading;
    // Polar to cartesian for force vector!
    PVector force = new PVector(cos(angle), sin(angle));
    force.mult(-0.90);
    applyForce(force); 
    // To draw booster
    thrusting = true;
  }


  void applyForce(PVector force) { //ex
    PVector f = force.get();
    force.div(mass);
    acceleration.add(f);
  }

  void display() { 
    int t = 90;
    float theta = velocity.heading2D();

    float period = 60;
    float period1 = 30;

    float amplitude = 10;
    float hm0 = amplitude * cos(TWO_PI * frameCount / period);
    float hm1 = (amplitude*(0.3)) * cos(TWO_PI * frameCount / period);
    float hm2 = (amplitude*(0.3)) * cos(TWO_PI * frameCount / period1);

    smooth();
    noStroke();

    pushMatrix();
    ellipseMode(CENTER);
    translate(location.x, location.y);
    rotate(heading);

    stroke(50); //tail
    strokeWeight(2);
    line(0, 0, -18, hm1);
    stroke(0, 0, 0, 200);
    fill(0);
    ellipse(-18, hm1, 4, 4);

    stroke(50); //tail
    strokeWeight(1);
    line(0, 5, -13, hm2+10);
    stroke(0, 0, 0, 200);
    fill(0);
    ellipse(-13, hm2+10, 2, 2);

    stroke(50); //tail
    strokeWeight(1);
    line(0, -5, -13, hm2-10);
    stroke(0, 0, 0, 200);
    fill(0);
    ellipse(-13, hm2-10, 2, 2);

    noStroke();
    fill(255);
    ellipse(12, 0, 40, 40);

    noStroke();
    fill(255, 0, 0);
    ellipse(0, hm1, 20, 20);
    fill(255);
    ellipse(0, hm1, 4, 4);

    stroke(255, 0, 0);
    ellipse(12, 0, 6, 6);

    /*
    stroke(50);
     strokeWeight(1);
     line(25, 0, 40, 0);
     stroke(0);
     fill(0);
     ellipse(40, 0, 6, 6);*/

    stroke(0, 0, 0, 200);
    noFill();
    strokeWeight(2);
    ellipse(12, 0, 43, 43);

    beginShape();
    noFill();
    smooth();
    stroke(0, 50);
    strokeWeight(1);

    for (PVector v: history) {
      vertex(v.x, v.y);
    }
    popMatrix();
    endShape();
    history.add(location.get());
    if (history.size() > 1000) {
      history.remove(0);
    }
    
    if (lifespan <= 0) {
    history = new ArrayList<PVector>();
    }

    /* float amplitude = 10;
     
     smooth();
     noStroke();
     pushMatrix();
     ellipseMode(CENTER);
     translate(location.x, location.y);
     stroke(0);
     strokeWeight(1);
     fill(255);
     ellipse(0, 0, 30, 30);
     ellipse(0, 0, 15, 15);
     popMatrix();
     //endShape();*/


    if (keyPressed) {
      if (key == 'a' || key == 'A' || key == CODED && keyCode == LEFT  && !playing) {
        //s.moveLeft();
        s.turn(-0.20);
        noStroke();
        //out.playNote(0.0, 1.5, "G3");
        //playing = true;
        //fill(240);
        rect(0, 0, 10, height);
      } 
      else if (key == 'd' || key == 'D' || key == CODED && keyCode == RIGHT && !playing) {
        //s.moveRight();
        s.turn(0.20);
        noStroke();
        //out.playNote(5.0, 1.5, "G3");
        //playing = true;

        //fill(240);
        rect(width-10, 0, width, height);
      } 
      else if (key == 'w' || key == 'W' || key == CODED && keyCode == UP && !playing) {
        s.thrust();
        noStroke();
        //playing = true;
        //fill(240);
        rect(0, 0, width, 10);
      }
      else if (key == 's' || key == 'S' || key == CODED && keyCode == DOWN && !playing) {
        s.thrust1();
        //out.playNote(5.0, 1.5, "G3");
        //playing = true;

        noStroke();
        //fill(240);
        rect(0, height-10, width, height);
      }
    }
    else if (!keyPressed) {
      playing = false;
    }
  }
}