//many thanks to Dan Shiffman

Sheep s;
Particle p;
//CA ca;
Walker w;

//ParticleSystem ps;

import ddf.minim.*;
import ddf.minim.ugens.*;

Minim minim;
AudioOutput out;

float soundChange;
float lifespan;
int collisions;
int c = 200;

boolean playing = false;
int soundie = 0;

int score;



void setup() {
  size(640, 480);
  frameRate(24);
  w = new Walker(new PVector(random(width), random(height)));
  s = new Sheep();
  p = new Particle(new PVector(random(width), random(height)));

  System.gc();

  minim = new Minim(this);
  out = minim.getLineOut(Minim.STEREO);
}

void draw() {
  background(255);

  dottedmiddle();
  dottedmiddle2();
  dottedmiddle3();

  particleLifebar();

  s.update();
  s.display();

  w.step();
  w.display();
  w.step1();
  w.display1();
  w.step2();
  w.display2();
  w.step3();
  w.display3();

  //ps.addParticle();
  //ps.run();

  p.run();

  if (s.isHit(p) && !playing) {
    rect(0, 0, width, height);
    fill(255, 0, 0, 100);

    String sounds = "C3,D3,E3,F3,G3";
    String[] list = split(sounds, ',');
    out.playNote(0.0, 1, list[soundie]);
    out.playNote(5.0, 1, "C4");

    out.playNote(15.1, 0.25, "C4");
    out.playNote(15.0, 0.25, "D4");
    out.playNote(14.9, 0.25, "C4");


    soundie++;

    if (soundie >= 5) {
      soundie = 0;
    }

    playing = true;
    p = new Particle(new PVector(random(width), random(height)));
    println("Particle dead! long live particle!");
  } 
  else if (!s.isHit(p)) {
    playing = false;
  }
  fill(0);
  text(score, width-25, 10);

  if (lifespan <=0) {
    score = 0;
  }
}

void particleLifebar() {
  float m = millis()/100;
  fill(255, 0, 0, 100);
  noStroke();
  rect(0, 0, lifespan, 5);
  fill(0, 0, 0, 200);
  noStroke();
}

void dottedmiddle() {

  stroke(c);
  smooth();
  strokeWeight(2);
  int x1 = width/4; 
  int y1 = 0; 
  int x2 = width/4; 
  int y2 = height; 
  for (int i=0; i<=25; i++) { 
    float x = lerp(x1, x2, i/25.0) + 2; 
    float y = lerp(y1, y2, i/25.0); 
    point(x, y); 
    line(x, y, x, y);
  }
}

void dottedmiddle2() {
  stroke(c);
  smooth();
  strokeWeight(4);
  int x1 = width/2; 
  int y1 = 0; 
  int x2 = width/2; 
  int y2 = height; 
  for (int i=0; i<=15; i++) { 
    float x = lerp(x1, x2, i/15.0) + 2; 
    float y = lerp(y1, y2, i/15.0); 
    point(x, y); 
    line(x, y, x, y);
  }
}

void dottedmiddle3() {
  stroke(c);
  smooth();
  strokeWeight(2);
  int x1 = width-(width/4); 
  int y1 = 0; 
  int x2 = width-(width/4); 
  int y2 = height; 
  for (int i=0; i<=25; i++) { 
    float x = lerp(x1, x2, i/25.0) + 2; 
    float y = lerp(y1, y2, i/25.0); 
    point(x, y); 
    line(x, y, x, y);
  }
}

void keyPressed() {
  if (key == 'q') {
    save("normal.png");
  }
}

void stop()
{
  out.close();
  minim.stop();
  super.stop();
}